##################################################################### 
##								      
##		  Problems 2-4					      
##								      
## This series of problems culminates in the implementation of a      
## histogram function which counts the number of occurrences of each  
## character in a string, and prints the resulting histogram to the   
## screen. For example, the histogram for the string "Hello, World!"  
## is:								      
##								      
##    |								      
##  ! |								      
##  , |								      
##  H |								      
##  W |								      
##  d |								      
##  e |								      
##  l |||							      
##  o ||							      
##  r |								      
##								      
## It is HIGHLY RECOMMENDED that you implement these functions in     
## problem order because the latter ones will depend on a working     
## implementation of the earlier ones.				     
##									      
## NB: At the bottom of this file several helper functions     
##     are provided for your use.					     
##
## NB: Each of your functions must adhere to MIPS calling conventions,
##     and take and return the arguments exactly as specified
##     (including their order).
##
## We have provided code in the body of main to test each function    
## individually.  Simply uncomment the tests that you would like to   
## run.								      
##								      
#####################################################################		      

	      .data
min_char:     .asciiz " "
max_char:     .asciiz "~"
bar:	      .asciiz "|"
separator:    .asciiz " "
newline:      .asciiz "\n"
hello:	      .asciiz "Hello, World!"
gettysburg:   .asciiz "Four score and seven years ago our fathers brought forth on this continent, a new nation, conceived in Liberty, and dedicated to the proposition that all men are created equal. Now we are engaged in a great civil war, testing whether that nation, or any nation so conceived and so dedicated, can long endure. We are met on a great battle-field of that war. We have come to dedicate a portion of that field, as a final resting place for those who here gave their lives that that nation might live. It is altogether fitting and proper that we should do this. But, in a larger sense, we can not dedicate -- we can not consecrate -- we can not hallow -- this ground. The brave men, living and dead, who struggled here, have consecrated it, far above our poor power to add or detract. The world will little note, nor long remember what we say here, but it can never forget what they did here. It is for us the living, rather, to be dedicated here to the unfinished work which they who fought here have thus far so nobly advanced. It is rather for us to be here dedicated to the great task remaining before us -- that from these honored dead we take increased devotion to that cause for which they gave the last full measure of devotion -- that we here highly resolve that these dead shall not have died in vain -- that this nation, under God, shall have a new birth of freedom -- and that government of the people, by the people, for the people, shall not perish from the earth."
	  
	      .text
	      .globl main
main:
####################################################################
##                 PROBLEM 2 TEST CODE (print_bucket)           
####################################################################

##            li    $a0, 42       # $a0 = '*'
##            li    $a1, 10	  # $a1 = 10    
##            jal   print_bucket  # should print: "* ||||||||||" on its own line

##            li    $a0, 45       # $a0 = '-'
##            li    $a1, 12	  # $a1 = 12
##            jal   print_bucket  # should print: "- ||||||||||||" on its own line
	      
##            li    $a0, 80       # $a0 = 'P'
##            li    $a1, 8	  # $a1 = 8
##            jal   print_bucket  # should print: "P ||||||||" on its own line

####################################################################
##                 PROBLEM 3 TEST CODE (count)                    
####################################################################
	      
##            li    $a0, 108        # $a0 = 'l'
##            la    $a1, hello
##            jal   count
##            move $a0, $v0
##            jal   print_int       # should print "3"

##            li    $a0, 33         # $a0 = '!'
##            la    $a1, hello
##            jal   count
##            move $a0, $v0
##            jal   print_int       # should print "1"

##            li    $a0, 98         # $a0 = 'b'
##            la    $a1, gettysburg
##            jal   count
##            move $a0, $v0
##            jal   print_int       # should print "13"

####################################################################
##                 PROBLEM 2 TEST CODE (histogram)               
####################################################################
	      
      
## 	      la    $a0, hello
## 	      jal   histogram

## 	      la    $a0, gettysburg
## 	      jal   histogram
     
	      li    $v0, 10          # exit
	      syscall

#######################################################################
##			  PROBLEM 4				        
##								        
## Implement the histogram function:						 
##	       void histogram(char* s)
##										 
## For each character c between *min_char and *max_char, histogram
## counts the number of occurrences of c in s, and prints out a bucket
## in the histogram for all non-zero counts.  
##								       	 
####################################################################### 
	      
histogram:
## 
##       Your code here
##

#######################################################################
##			  PROBLEM 3				        
##								        
## Implement the count function:						 
##	       int count(char c, char* s)
##										 
## count counts the number of instances of a character (c) in a string
## (s).  
##								       	 
####################################################################### 
	      
count:	      
## 
##       Your code here
##

######################################################################
##			  PROBLEM 2				        
##								        
## Implement the print_bucket function:						 
##	       void print_bucket(char c, int n)					 
##										 
## print_bucket takes two arguments, a character (c) and an			 
## integer (n) indicating how many instances of c were found in	        
## some string.	 This function should print the corresponding bucket   	 
## in the histogram.						       	 
##								       	 
## A bucket consists of a label, followed by n bars, followed by a     	 
## newline.  For example, print_bucket('a', 2) should print "a ||\n".  	 
##										 
####################################################################### 
   
print_bucket: 
## 
##       Your code here
##
	      
####################################################################
##                 HELPER FUNCTIONS                               ##
####################################################################

print_label:                         # void print_label(char c)
	      addi  $sp, $sp, -4     
	      sw    $ra, 0($sp)
	      jal   print_char       
	      jal   print_separator  
	      lw    $ra, 0($sp)      
	      addi  $sp, $sp, 4
	      jr    $ra
	      
print_bar:                           # void print_bar()
	      la    $a0, bar
	      li    $v0, 4
	      syscall
	      jr    $ra

print_separator:                     # void print_separator()
	      la    $a0, separator
	      li    $v0, 4
	      syscall
	      jr    $ra
	      
print_newline:                       # void print_newline()
	      la    $a0, newline
	      li    $v0, 4
	      syscall
	      jr    $ra

print_char:   li    $v0, 11          # void print_char(char c)
	      syscall
	      jr    $ra

	      
print_int:    li    $v0, 1           # void print_int(int i)
	      syscall
	      li    $v0, 4
	      la    $a0, newline
	      syscall
	      jr    $ra
	      